/*
 *  stereo -- Stereo matching software
 *  $Id: myopencv.c 303 2004-09-09 12:01:14Z eric $
 *  Copyright (c) 2004 Sam Hocevar <sam@zoy.org>
 *                     Éric Beets <ericbeets@free.fr>
 *  All Rights Reserved
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 *  02111-1307  USA
 */

#include <stdint.h>

#include "defs.h"
#include "image.h"

#include <cv.h>
#include <highgui.h>

/*
int Resize(image_t *img,image_t *dst,float factor)
{
	cvResize(img->_private,dst->_private,CV_INTER_NN);
	return 0;
}
*/
int GetSubImage(image_t *img,image_t *dst,int x,int y, int width,int height)
{
	CvRect r;
	image_new(dst, width,height,img->depth);
	if(!img)
		return 0;
	/* Définition des dimension de l'imagette */
	r = cvRect(x, y, width,height); 
	cvSetImageROI(img->_private, r);  
	/* Copie de l'imagette */
	cvCopyImage(img->_private, dst->_private);  
	/* re-initiliaion des dimensions de l'image */
	r = cvRect(0,0,img->width,img->height); 
	cvSetImageROI(img->_private, r);  
	return 0;
}
int SetSubImage(image_t *img,image_t *dst,int x,int y, int width,int height)
{
	CvRect r;
	image_new(dst, width,height,img->depth);
	if(!img)
		return 0;
	/* Définition des dimension de l'imagette */
	r = cvRect(x, y, width,height); 
	cvSetImageROI(img->_private, r);  
	/* Copie de l'imagette */
	cvCopyImage(img->_private, dst->_private);  
	/* re-initiliaion des dimensions de l'image */
	r = cvRect(0,0,img->width,img->height); 
	cvSetImageROI(img->_private, r);  
	return 0;
}


void SetPixel(image_t *image,int x, int y,uchar R,uchar G,uchar B)
{
	IplImage *tmp = image->_private;
	if(y <0 || x<0 || y  >= image->height || x >= image->width)
		return;
	((uchar*)(tmp->imageData + 	tmp->widthStep*y))[x*tmp->nChannels ] = B;
	((uchar*)(tmp->imageData + 	tmp->widthStep*y))[x*tmp->nChannels+1] = G;
	((uchar*)(tmp->imageData + 	tmp->widthStep*y))[x*tmp->nChannels+2] = R;
}
void GetPixel(image_t *image,int x, int y,uchar *R,uchar *G,uchar *B)
{
	IplImage *tmp = image->_private;
	if(y <0 || x<0 || x >= image->width || y >= image->height)
	{
		*R = 255*1;
		*G = 0;
		*B = 255*1;
		return ;
	}
	*B = ((uchar*)(tmp->imageData + 	tmp->widthStep*y))[x*tmp->nChannels ];
	*G = ((uchar*)(tmp->imageData + 	tmp->widthStep*y))[x*tmp->nChannels+1];
	*R = ((uchar*)(tmp->imageData + 	tmp->widthStep*y))[x*tmp->nChannels+2];
}
